// Copyright (c) 2019, Cthulhu
//
// Redistribution and use in source and binary forms,
// with or without modification,
// are permitted provided that the following conditions are met:
//
// 1. Redistributions of source code must retain the above copyright notice,
//    this list of conditions and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright notice,
//    this list of conditions and the following disclaimer in the documentation
//    and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

if {defined CATFOOD} {

macro catfood(variable check, variable value, variable ounces) {
    if ounces < 0 || ounces > 200 {
        error "Invalid ounces for catfood (0-200)."
    }

    variable limit(200 - ounces)

    seek(check)
        db limit  // Limit check
    seek(value)
        db ounces // Value (Ounces)
}

if {defined EX} {
catfood($DBDB63, $DBDB66, 10)  // Guessing Game
catfood($DBDBC7, $DBDBCA, 50)  // Copycat Game
catfood($DBD8FC, $DBD907, 100) // Beanbag Throw Game
} else {
catfood($DB72E8, $DB72EB, 10)  // Guessing Game
catfood($DB734C, $DB734F, 50)  // Copycat Game
catfood($DB7081, $DB708C, 100) // Beanbag Throw Game
}

}
