// Copyright (c) 2019, Cthulhu
//
// Redistribution and use in source and binary forms,
// with or without modification,
// are permitted provided that the following conditions are met:
//
// 1. Redistributions of source code must retain the above copyright notice,
//    this list of conditions and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright notice,
//    this list of conditions and the following disclaimer in the documentation
//    and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

// Chrono Trigger ASCII Tiles
map $41,$A0,26 // A-Z
map $61,$BA,26 // a-z
map $30,$D4,10 // 0-9
map $21,$DE    // !
map $3F,$DF    // ?
map $2F,$E0    // /
map $22,$E1    // "
//map $22,$E2  // "
map $3A,$E3    // :
map $26,$E4    // &
map $5B,$E5    // [
map $5D,$E6    // ]
map $27,$E7    // '
map $2E,$E8    // .
map $2C,$E9    // ,
map $3D,$EA    // =
map $2D,$EB    // -
map $2B,$EC    // +
map $25,$ED    // %
map $23,$F3    // #
map $20,$FF    //  

// +++ Ayla's Charm Tech +++

// Control Header
seek($CC1DE2) // [Hit Effects]
    db $00    // None
    db $00    // None
    db $00    // None

// Effect Header #1
seek($CC235B) // [Mode]
    db $02    // Status Impact
    db $01    // Negative Status
seek($CC235D) // [Status]
    db $80    // Stop
seek($CC2360) // [Chance]
    db 80     // Base
    db 0      // Bonus
seek($CC2362) // [Options]
    db $40    // Ignore Shield Status

// Animation Objects
seek($CE2D7C) // [Effect Object #6]
    db $35    // Increment Counter 1C Flow Control
    dw $0523  // Wait for Counter 1C Flow Control ($05)
    db $71    // Drawing Status: Hide Effect
    fill 5    // Return

// Tech Description
if {defined EX} {
seek($F68417)
} else {
seek($CC3E23)
}
    db $B2,$32,$C9,$EF,$33,$BE,$C6,$D2 // Stop enemy (compressed)
    fill 4

// --- Ayla's Charm Tech ---

// +++ Marle & Ayla's Twin Charm Tech +++

// Control Header
seek($CC1F67) // [Overrides]
    db $00    // None
seek($CC1F6E) // [Hit Effects]
    db $1E    // 100% chance of 50% HP damage
    db $00    // None
    db $00    // None

// Effect Header #1
seek($CC2463) // [Mode]
    db $03    // Damage
seek($CC2464) // [Status]
    db 100    // Chance
    db $04    // Confuse
seek($CC2466) // [Stats]
    db $00    // Hit (None)
    db $00    // Evade (None)
    db $00    // Formula (None)
    db $00    // Defense (None)
seek($CC246A) // [Options]
    db $C4    // Inflict Status, Ignore Shield Status, Ignore Barrier Status
seek($CC246B) // [Damage]
    db $00    // Modifier
    db $01    // Power

// Animation Objects
seek($CE4F6B) // [Effect Object #7]
    db $35    // Increment Counter 1C Flow Control
    dw $0523  // Wait for Counter 1C Flow Control ($05)
    db $71    // Drawing Status: Hide Effect
    fill 5    // Return

// Tech Description
if {defined EX} {
seek($F686ED)
} else {
seek($CC40F1)
}
    db $A7,$4D,$3A,$CC,$EF,$33,$BE,$C6,$D2,$EF,$A7,$AF // Halves enemy HP (compressed)

// --- Marle & Ayla's Twin Charm Tech ---

// +++ Charm Top Accessory +++

// Effects
seek($CC0571)
    db $80 // [Status]
    db $09 // Positive Status #2
    db $6C // Max Attack Power Up, MP Regen, Shield, Barrier

// Equipable By
seek($CC0A63)
    db $40 // Marle only

// Item Name
seek($CC1275)
    db $29,"Crown"
    fill 5,$EF

// Item Description
if {defined EX} {
seek($F6F5B4)
} else {
seek($CC3477)
}
    db $B1,$C8,$D2,$4D,$EF,$AF,$62,$26 // Royal Power (compressed)
    fill 5

// --- Charm Top Accessory ---
