@echo off & SETLOCAL EnableDelayedExpansion & TITLE Chrono Trigger - Enemy Drops Overhaul

rem set DEFINE=EX,CATFOOD

set INPUT="Chrono Trigger (USA).sfc"
set SOURCE="main.asm"
set OUTPUT="chrono_drops.sfc"

if not exist %INPUT% (
    echo [ERROR] ROM not found^^!

    set /A exit_code=1
    goto exit
)

if not exist %SOURCE% (
    echo [ERROR] Source code not found^^!

    set /A exit_code=1
    goto exit
)

if not exist bass.exe (
    echo [ERROR] bass not found^^!

    set /A exit_code=1
    goto exit
)

:copy
echo [*] Copying ROM...

copy /V /Y %INPUT% /B %OUTPUT% /B > nul

if %ERRORLEVEL% NEQ 0 goto error

:assemble
echo [*] Assembling...

if defined DEFINE (
    set defines=

    for %%a in (%DEFINE%) do set defines=!defines! -d %%a
)

if defined defines (
    bass !defines! -o %OUTPUT% %SOURCE%
) else (
    bass -o %OUTPUT% %SOURCE%
)

if %ERRORLEVEL% NEQ 0 goto error

:checksum
if exist checksum.exe (
    echo [*] Calculating checksum...

    checksum %OUTPUT%

    if %ERRORLEVEL% NEQ 0 goto error
)

if not exist flips.exe goto success

echo.

:confirm_bps
set /P do_bps="Create BPS patch? [Y]es/[N]o: "

if "%do_bps%"=="y" goto bps
if "%do_bps%"=="Y" goto bps
if "%do_bps%"=="n" goto success
if "%do_bps%"=="N" goto success

goto confirm_bps

:bps
echo.
echo [*] Creating BPS patch...

flips -c -b %INPUT% %OUTPUT% > nul

if %ERRORLEVEL% NEQ 0 goto error

:success
echo.
echo [*] All done^^!

set /A exit_code=0

:exit
echo.
pause

exit %exit_code%

:error
echo ***ERROR***

set /A exit_code=3
goto exit
